/*
 * Created with SharpDevelop.
 * Author: Markus Schlichting, m.schlichting@mynethome.de
 * 
 * Released unter the GNU GPL.
 */

//Idee fr ftp: http://www.c-sharpcorner.com/Code/2003/April/FtpClient.asp




using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace ImageResizer
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnZielverzeichnisAendern;
		private System.Windows.Forms.MenuItem mnuDateiBeenden;
		private System.Windows.Forms.MenuItem mnuHelpAbout;
		private System.Windows.Forms.Button btnVerarbeiten;
		private System.Windows.Forms.MenuItem mnuHelp;
		private System.Windows.Forms.Button btnChooseWatermarkFile;
		private System.Windows.Forms.Button btnImageListClean;
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.Label txtStatus;
		private System.Windows.Forms.ProgressBar progressBar;
		private System.Windows.Forms.TextBox txtZielVerzeichnis;
		private System.Windows.Forms.TextBox txtWatermarkFile;
		private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
		private System.Windows.Forms.TextBox txtMaxBreite;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.MenuItem mnuDatei;
		private System.Windows.Forms.CheckBox chkSetWatermark;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtMaxHoehe;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.Button btnBilderLaden;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox chkUpload;
		private System.Windows.Forms.RadioButton radioBtnFlickr;
        private System.Windows.Forms.RadioButton radioBtnFTP;
		
		//Private property to store the watermarkobject
		private System.Drawing.Image imgWatermark;
        private System.ComponentModel.IContainer components;
        private GroupBox groupBox4;
        private CheckBox chkFilenamePrefix;
        private TextBox txtFilenamePrefix;
        private ContextMenuStrip contextMenuListbox;
        private ToolStripMenuItem entfernenToolStripMenuItem;
		
		//Private member
		private Properties.Settings _AppSettings;

		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();

            _AppSettings = new Properties.Settings();
			this.txtZielVerzeichnis.Text = _AppSettings.TargetDirectory;
            this.txtMaxBreite.Text = _AppSettings.ResizeWidth.ToString();
            this.txtMaxHoehe.Text = _AppSettings.ResizeHeight.ToString();
            this.txtWatermarkFile.Text = _AppSettings.WatermarkFile;
			//Watermark Steuerelemente deaktivieren.
			this.btnChooseWatermarkFile.Enabled = false;
	 		this.txtWatermarkFile.Enabled = false;
	 		this.txtWatermarkFile.Text = "";
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.btnBilderLaden = new System.Windows.Forms.Button();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.txtMaxHoehe = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.chkSetWatermark = new System.Windows.Forms.CheckBox();
            this.mnuDatei = new System.Windows.Forms.MenuItem();
            this.mnuDateiBeenden = new System.Windows.Forms.MenuItem();
            this.label4 = new System.Windows.Forms.Label();
            this.txtMaxBreite = new System.Windows.Forms.TextBox();
            this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.mnuHelp = new System.Windows.Forms.MenuItem();
            this.mnuHelpAbout = new System.Windows.Forms.MenuItem();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.btnChooseWatermarkFile = new System.Windows.Forms.Button();
            this.txtWatermarkFile = new System.Windows.Forms.TextBox();
            this.txtZielVerzeichnis = new System.Windows.Forms.TextBox();
            this.progressBar = new System.Windows.Forms.ProgressBar();
            this.txtStatus = new System.Windows.Forms.Label();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.contextMenuListbox = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.entfernenToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.btnImageListClean = new System.Windows.Forms.Button();
            this.btnVerarbeiten = new System.Windows.Forms.Button();
            this.btnZielverzeichnisAendern = new System.Windows.Forms.Button();
            this.label5 = new System.Windows.Forms.Label();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.radioBtnFTP = new System.Windows.Forms.RadioButton();
            this.radioBtnFlickr = new System.Windows.Forms.RadioButton();
            this.chkUpload = new System.Windows.Forms.CheckBox();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.txtFilenamePrefix = new System.Windows.Forms.TextBox();
            this.chkFilenamePrefix = new System.Windows.Forms.CheckBox();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.contextMenuListbox.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnBilderLaden
            // 
            this.btnBilderLaden.Location = new System.Drawing.Point(264, 96);
            this.btnBilderLaden.Name = "btnBilderLaden";
            this.btnBilderLaden.Size = new System.Drawing.Size(75, 23);
            this.btnBilderLaden.TabIndex = 1;
            this.btnBilderLaden.Text = "Bilder laden";
            this.btnBilderLaden.Click += new System.EventHandler(this.BtnBilderLadenClick);
            // 
            // txtMaxHoehe
            // 
            this.txtMaxHoehe.Location = new System.Drawing.Point(92, 48);
            this.txtMaxHoehe.Name = "txtMaxHoehe";
            this.txtMaxHoehe.Size = new System.Drawing.Size(48, 20);
            this.txtMaxHoehe.TabIndex = 5;
            this.txtMaxHoehe.Text = "600";
            this.txtMaxHoehe.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.txtMaxHoehe.TextChanged += new System.EventHandler(this.txtMaxHoehe_TextChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(22, 49);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 23);
            this.label1.TabIndex = 0;
            this.label1.Text = "max. Hhe";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(22, 24);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(64, 23);
            this.label2.TabIndex = 0;
            this.label2.Text = "max. Breite";
            // 
            // label3
            // 
            this.label3.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label3.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(28, 82);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(112, 23);
            this.label3.TabIndex = 0;
            this.label3.Text = "Mae in Pixel.";
            // 
            // chkSetWatermark
            // 
            this.chkSetWatermark.Location = new System.Drawing.Point(11, 24);
            this.chkSetWatermark.Name = "chkSetWatermark";
            this.chkSetWatermark.Size = new System.Drawing.Size(144, 24);
            this.chkSetWatermark.TabIndex = 0;
            this.chkSetWatermark.Text = "Wasserzeichen setzen";
            this.chkSetWatermark.CheckedChanged += new System.EventHandler(this.ChkSetWatermarkCheckedChanged);
            // 
            // mnuDatei
            // 
            this.mnuDatei.Index = 0;
            this.mnuDatei.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuDateiBeenden});
            this.mnuDatei.Text = "Datei";
            // 
            // mnuDateiBeenden
            // 
            this.mnuDateiBeenden.Index = 0;
            this.mnuDateiBeenden.Text = "Beenden";
            this.mnuDateiBeenden.Click += new System.EventHandler(this.mnuDateiBeenden_Click);
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 56);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 12);
            this.label4.TabIndex = 2;
            this.label4.Text = "Datei";
            // 
            // txtMaxBreite
            // 
            this.txtMaxBreite.Location = new System.Drawing.Point(92, 24);
            this.txtMaxBreite.Name = "txtMaxBreite";
            this.txtMaxBreite.Size = new System.Drawing.Size(48, 20);
            this.txtMaxBreite.TabIndex = 4;
            this.txtMaxBreite.Text = "800";
            this.txtMaxBreite.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.txtMaxBreite.TextChanged += new System.EventHandler(this.txtMaxBreite_TextChanged);
            // 
            // folderBrowserDialog
            // 
            this.folderBrowserDialog.Description = "Zielpfad fr die skaliereten Bilder auswhlen:";
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuDatei,
            this.mnuHelp});
            // 
            // mnuHelp
            // 
            this.mnuHelp.Index = 1;
            this.mnuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuHelpAbout});
            this.mnuHelp.Text = "?";
            // 
            // mnuHelpAbout
            // 
            this.mnuHelpAbout.Index = 0;
            this.mnuHelpAbout.Text = "ber..";
            this.mnuHelpAbout.Click += new System.EventHandler(this.mnuHelpAbout_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.txtMaxBreite);
            this.groupBox1.Controls.Add(this.txtMaxHoehe);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Location = new System.Drawing.Point(13, 128);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(168, 124);
            this.groupBox1.TabIndex = 5;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Zielformat";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.btnChooseWatermarkFile);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.txtWatermarkFile);
            this.groupBox2.Controls.Add(this.chkSetWatermark);
            this.groupBox2.Location = new System.Drawing.Point(420, 128);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(168, 124);
            this.groupBox2.TabIndex = 9;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Wasserzeichen";
            // 
            // btnChooseWatermarkFile
            // 
            this.btnChooseWatermarkFile.Location = new System.Drawing.Point(136, 72);
            this.btnChooseWatermarkFile.Name = "btnChooseWatermarkFile";
            this.btnChooseWatermarkFile.Size = new System.Drawing.Size(24, 21);
            this.btnChooseWatermarkFile.TabIndex = 3;
            this.btnChooseWatermarkFile.Text = "...";
            this.btnChooseWatermarkFile.Click += new System.EventHandler(this.BtnChooseWatermarkFileClick);
            // 
            // txtWatermarkFile
            // 
            this.txtWatermarkFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.txtWatermarkFile.Location = new System.Drawing.Point(8, 72);
            this.txtWatermarkFile.Name = "txtWatermarkFile";
            this.txtWatermarkFile.ReadOnly = true;
            this.txtWatermarkFile.Size = new System.Drawing.Size(128, 20);
            this.txtWatermarkFile.TabIndex = 1;
            // 
            // txtZielVerzeichnis
            // 
            this.txtZielVerzeichnis.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.txtZielVerzeichnis.Location = new System.Drawing.Point(87, 277);
            this.txtZielVerzeichnis.Name = "txtZielVerzeichnis";
            this.txtZielVerzeichnis.ReadOnly = true;
            this.txtZielVerzeichnis.Size = new System.Drawing.Size(667, 20);
            this.txtZielVerzeichnis.TabIndex = 2;
            // 
            // progressBar
            // 
            this.progressBar.Location = new System.Drawing.Point(12, 344);
            this.progressBar.Name = "progressBar";
            this.progressBar.Size = new System.Drawing.Size(770, 23);
            this.progressBar.TabIndex = 8;
            // 
            // txtStatus
            // 
            this.txtStatus.Location = new System.Drawing.Point(469, 312);
            this.txtStatus.Name = "txtStatus";
            this.txtStatus.Size = new System.Drawing.Size(293, 23);
            this.txtStatus.TabIndex = 0;
            this.txtStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // listBox1
            // 
            this.listBox1.ContextMenuStrip = this.contextMenuListbox;
            this.listBox1.Location = new System.Drawing.Point(13, 0);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new System.Drawing.Size(769, 95);
            this.listBox1.TabIndex = 0;
            this.listBox1.DoubleClick += new System.EventHandler(this.listBox1_DoubleClick);
            // 
            // contextMenuListbox
            // 
            this.contextMenuListbox.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.entfernenToolStripMenuItem});
            this.contextMenuListbox.Name = "contextMenuListbox";
            this.contextMenuListbox.Size = new System.Drawing.Size(134, 26);
            // 
            // entfernenToolStripMenuItem
            // 
            this.entfernenToolStripMenuItem.Image = global::ImageResizer.Properties.Resources.delete_16x;
            this.entfernenToolStripMenuItem.Name = "entfernenToolStripMenuItem";
            this.entfernenToolStripMenuItem.Size = new System.Drawing.Size(133, 22);
            this.entfernenToolStripMenuItem.Text = "entfernen";
            this.entfernenToolStripMenuItem.Click += new System.EventHandler(this.entfernenToolStripMenuItem_Click);
            // 
            // btnImageListClean
            // 
            this.btnImageListClean.Location = new System.Drawing.Point(456, 96);
            this.btnImageListClean.Name = "btnImageListClean";
            this.btnImageListClean.Size = new System.Drawing.Size(75, 23);
            this.btnImageListClean.TabIndex = 2;
            this.btnImageListClean.Text = "Liste leeren";
            this.btnImageListClean.Click += new System.EventHandler(this.BtnImageListCleanClick);
            // 
            // btnVerarbeiten
            // 
            this.btnVerarbeiten.Image = global::ImageResizer.Properties.Resources.servicerunning;
            this.btnVerarbeiten.Location = new System.Drawing.Point(330, 303);
            this.btnVerarbeiten.Name = "btnVerarbeiten";
            this.btnVerarbeiten.Size = new System.Drawing.Size(133, 35);
            this.btnVerarbeiten.TabIndex = 6;
            this.btnVerarbeiten.Text = "Bilder verarbeiten";
            this.btnVerarbeiten.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
            this.btnVerarbeiten.Click += new System.EventHandler(this.BtnVerarbeitenClick);
            // 
            // btnZielverzeichnisAendern
            // 
            this.btnZielverzeichnisAendern.Location = new System.Drawing.Point(758, 276);
            this.btnZielverzeichnisAendern.Name = "btnZielverzeichnisAendern";
            this.btnZielverzeichnisAendern.Size = new System.Drawing.Size(24, 21);
            this.btnZielverzeichnisAendern.TabIndex = 3;
            this.btnZielverzeichnisAendern.Text = "...";
            this.btnZielverzeichnisAendern.Click += new System.EventHandler(this.BtnZielverzeichnisAendernClick);
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(12, 277);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(87, 20);
            this.label5.TabIndex = 10;
            this.label5.Text = "Zielverzeichnis";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.radioBtnFTP);
            this.groupBox3.Controls.Add(this.radioBtnFlickr);
            this.groupBox3.Controls.Add(this.chkUpload);
            this.groupBox3.Location = new System.Drawing.Point(614, 128);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(168, 124);
            this.groupBox3.TabIndex = 11;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Upload";
            // 
            // radioBtnFTP
            // 
            this.radioBtnFTP.Enabled = false;
            this.radioBtnFTP.Location = new System.Drawing.Point(40, 72);
            this.radioBtnFTP.Name = "radioBtnFTP";
            this.radioBtnFTP.Size = new System.Drawing.Size(104, 24);
            this.radioBtnFTP.TabIndex = 2;
            this.radioBtnFTP.Text = "FTP";
            this.radioBtnFTP.CheckedChanged += new System.EventHandler(this.radioBtnFTP_CheckedChanged);
            // 
            // radioBtnFlickr
            // 
            this.radioBtnFlickr.Enabled = false;
            this.radioBtnFlickr.Location = new System.Drawing.Point(40, 48);
            this.radioBtnFlickr.Name = "radioBtnFlickr";
            this.radioBtnFlickr.Size = new System.Drawing.Size(104, 24);
            this.radioBtnFlickr.TabIndex = 1;
            this.radioBtnFlickr.Text = "Flickr!";
            this.radioBtnFlickr.CheckedChanged += new System.EventHandler(this.radioBtnFlickr_CheckedChanged);
            // 
            // chkUpload
            // 
            this.chkUpload.Location = new System.Drawing.Point(8, 24);
            this.chkUpload.Name = "chkUpload";
            this.chkUpload.Size = new System.Drawing.Size(154, 24);
            this.chkUpload.TabIndex = 0;
            this.chkUpload.Text = "Bilder direkt hochladen";
            this.chkUpload.CheckedChanged += new System.EventHandler(this.chkUpload_CheckedChanged);
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.txtFilenamePrefix);
            this.groupBox4.Controls.Add(this.chkFilenamePrefix);
            this.groupBox4.Location = new System.Drawing.Point(213, 128);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(168, 124);
            this.groupBox4.TabIndex = 12;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "Ziel-Dateinamen";
            // 
            // txtFilenamePrefix
            // 
            this.txtFilenamePrefix.Location = new System.Drawing.Point(8, 76);
            this.txtFilenamePrefix.Name = "txtFilenamePrefix";
            this.txtFilenamePrefix.Size = new System.Drawing.Size(148, 20);
            this.txtFilenamePrefix.TabIndex = 1;
            this.txtFilenamePrefix.Text = "scaled-";
            // 
            // chkFilenamePrefix
            // 
            this.chkFilenamePrefix.Checked = true;
            this.chkFilenamePrefix.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkFilenamePrefix.Location = new System.Drawing.Point(8, 24);
            this.chkFilenamePrefix.Name = "chkFilenamePrefix";
            this.chkFilenamePrefix.Size = new System.Drawing.Size(144, 37);
            this.chkFilenamePrefix.TabIndex = 0;
            this.chkFilenamePrefix.Text = "Prefix den Dateinamen voranstellen:";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(794, 379);
            this.Controls.Add(this.groupBox4);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.txtStatus);
            this.Controls.Add(this.progressBar);
            this.Controls.Add(this.btnImageListClean);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.btnZielverzeichnisAendern);
            this.Controls.Add(this.btnVerarbeiten);
            this.Controls.Add(this.txtZielVerzeichnis);
            this.Controls.Add(this.btnBilderLaden);
            this.Controls.Add(this.listBox1);
            this.Controls.Add(this.label5);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.Text = "Image Resizer";
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.contextMenuListbox.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.groupBox4.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		void BtnBilderLadenClick(object sender, System.EventArgs e){
           openFileDialog.Multiselect = true ;
            openFileDialog.Filter = "Fotos (*.jpg)|*.jpg" ;

            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
                if (openFileDialog.FileNames != null)
                {
                    for(int i =0 ; i < openFileDialog.FileNames.Length ; i++ )
                    {
                        addImage(openFileDialog.FileNames[i]);
                    }
                }
                else
                    addImage(openFileDialog.FileName);
            }
        }
		
		private void addImage(string imageToLoad)
        {
            if (!String.IsNullOrEmpty(imageToLoad))
            {
                listBox1.BeginUpdate();
                listBox1.Items.Add(imageToLoad);
                listBox1.EndUpdate();
            }
        }
				
		void BtnZielverzeichnisAendernClick(object sender, System.EventArgs e)
		{
			folderBrowserDialog.SelectedPath = this.txtZielVerzeichnis.Text;
			if(this.folderBrowserDialog.ShowDialog() == DialogResult.OK){				
				this.txtZielVerzeichnis.Text = folderBrowserDialog.SelectedPath;
				_AppSettings.TargetDirectory = folderBrowserDialog.SelectedPath;
				_AppSettings.Save();
			}
		}
		
		void BtnImageListCleanClick(object sender, System.EventArgs e)
		{
			listBox1.BeginUpdate();
			listBox1.Items.Clear();
			listBox1.EndUpdate();
			
			this.progressBar.Value = 0;
			this.txtStatus.Text = "";
		}
		
		void BtnVerarbeitenClick(object sender, System.EventArgs e)
		{
            FlickrAccess fa;
            string imgFileName;

            this.txtStatus.Text = "";
			this.progressBar.Value = 0;
			this.Cursor = Cursors.WaitCursor;
			this.btnVerarbeiten.Text = "Bitte warten...";

            try
            {
                //Checken, ob angegebener Pfad vorhanden
                if (!Directory.Exists(this.txtZielVerzeichnis.Text))
                {
                    Directory.CreateDirectory(this.txtZielVerzeichnis.Text);
                }

                if (listBox1.Items.Count != 0)
                {
                    //initialize Progressbar
                    progressBar.Maximum = listBox1.Items.Count;
                    progressBar.Step = 1;
                    progressBar.Value = 0;

                    //instanciate Watermark-Object, if "is chosen"
                    if (this.chkSetWatermark.Checked)
                    {
                        imgWatermark = System.Drawing.Image.FromFile(this.txtWatermarkFile.Text);
                    }

                    for (int currentImage = 0; currentImage < listBox1.Items.Count; currentImage++)
                    {
                        string sThumbName;

                        listBox1.SelectedIndex = currentImage;
                        //Get Filename from Path
                        string[] sTmpPathSplit = listBox1.Text.Split(System.IO.Path.DirectorySeparatorChar);

                        sThumbName = sTmpPathSplit[sTmpPathSplit.Length - 1];
                        if (chkFilenamePrefix.Checked)
                        {
                            System.Text.StringBuilder sb = new System.Text.StringBuilder();
                            sb.Append(txtFilenamePrefix.Text);
                            sb.Append(sThumbName);
                            sThumbName = sb.ToString();
                        }

                        txtStatus.Text = sThumbName;
                        imgFileName = GenerateScaledImage(listBox1.Text, this.txtZielVerzeichnis.Text, 
                                                            sThumbName, System.Drawing.Imaging.ImageFormat.Jpeg);
                        if (chkUpload.Checked)
                        {
                            if (radioBtnFlickr.Checked)
                            {
                                fa = new FlickrAccess();
                                //fa.continueAuthMe();
                                fa.uploadPicture(imgFileName);
                            }
                            if (radioBtnFTP.Checked)
                            {
                                _AppSettings.Reload();
                                FtpUpload(_AppSettings.FtpServer, _AppSettings.FtpUser, _AppSettings.FtpPassword, _AppSettings.FtpPath, imgFileName);
                            }
                        }
                        progressBar.PerformStep();
                    }

                    txtStatus.Text = "Verarbeitung abgeschlossen.";

                }
            }catch (Exception ex)  { 
        		MessageBox.Show(ex.Message + ex.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        	}
			this.btnVerarbeiten.Text = "Bilder verarbeiten";
			this.Cursor = Cursors.Default;
		}
		
	 public string GenerateScaledImage(string sOriginalPhysicalPath,string sDestinationPath,
                                        string sScaledImageFileName, System.Drawing.Imaging.ImageFormat oFormat)
       	  {
		  	Int32 iScaledWidth= new Int32();
			Int32 iScaledHeight = new Int32();
        		
		  	
            try{
        		System.Drawing.Image oImg = System.Drawing.Image.FromFile(sOriginalPhysicalPath); 
	        		if(oImg.Height>oImg.Width){
        				iScaledHeight = Convert.ToInt32(this.txtMaxHoehe.Text);
	        			iScaledWidth = (int)((double)((double)oImg.Width/(double)oImg.Height)*(double)iScaledHeight);
	        		}
        			if(oImg.Height<oImg.Width){
        				iScaledWidth = Convert.ToInt32(this.txtMaxBreite.Text);
        				iScaledHeight = (int)((double)((double)oImg.Height/(double)oImg.Width)*(double)iScaledWidth);
	        		}
        		
				System.Drawing.Image oScaledImage = new Bitmap(iScaledWidth, iScaledHeight, oImg.PixelFormat);
				Graphics oGraphic = Graphics.FromImage(oScaledImage);
				oGraphic.CompositingQuality = CompositingQuality.HighQuality ;
				oGraphic.SmoothingMode = SmoothingMode.HighQuality ;
				oGraphic.InterpolationMode = InterpolationMode.HighQualityBicubic ;
				Rectangle oRectangle = new Rectangle(0, 0, iScaledWidth, iScaledHeight);

                oGraphic.DrawImage(oImg, oRectangle);
                if(this.chkSetWatermark.Checked){
                	oGraphic.DrawImageUnscaled(imgWatermark, 10, 10);
                }
               

                System.Text.StringBuilder FileNameBuilder = new System.Text.StringBuilder();
                FileNameBuilder.Append(sDestinationPath);
                //FileNameBuilder.Append(@"\");
                FileNameBuilder.Append(sScaledImageFileName);
                String Filename = FileNameBuilder.ToString();
                oScaledImage.Save(Filename,oFormat); 
		  
                oImg.Dispose();
                return Filename;

            }catch (Exception e)  { 
        		MessageBox.Show(e.Message + e.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return "";
        	}
                

       }
		  
	 private void mnuHelpAbout_Click(object sender, System.EventArgs e)
		{
		    AboutScreen a = new AboutScreen();
		    a.ShowDialog();
		}

	
	 private void mnuDateiBeenden_Click(object sender, System.EventArgs e)
		{ 
	 		this.Close();		    
		}

		 
	 void ChkSetWatermarkCheckedChanged(object sender, System.EventArgs e)
	 {
	 	if(this.chkSetWatermark.Checked){
	 		this.btnChooseWatermarkFile.Enabled = true;
	 		this.txtWatermarkFile.Enabled = true;
	 	}else{
	 		this.btnChooseWatermarkFile.Enabled = false;
	 		this.txtWatermarkFile.Enabled = false;
	 		//this.txtWatermarkFile.Text = "";
	 	}
	 }
	 
	 void BtnChooseWatermarkFileClick(object sender, System.EventArgs e)
	 {
	 	    openFileDialog.Multiselect = false ;
            openFileDialog.Filter = "Bilder (*.jpg, *.png, *.gif)|*.jpg;*.png;*.gif" ;

            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
        		this.txtWatermarkFile.Text = openFileDialog.FileName;
                _AppSettings.WatermarkFile = openFileDialog.FileName;
                _AppSettings.Save();
	 		}
	 }

		private void txtMaxBreite_TextChanged(object sender, System.EventArgs e)
		{
			_AppSettings.ResizeWidth = Int32.Parse(txtMaxBreite.Text);
            _AppSettings.Save();
		}

		private void txtMaxHoehe_TextChanged(object sender, System.EventArgs e)
		{
            _AppSettings.ResizeWidth = Int32.Parse(txtMaxBreite.Text);
			_AppSettings.Save();
		}

        private void listBox1_DoubleClick(object sender, EventArgs e)
        {
            if (listBox1.SelectedIndex != -1)
            {
                PicView pv = new PicView();
                pv.Image = Image.FromFile(listBox1.SelectedItem.ToString());
                pv.Scale();
                pv.ShowDialog();
            }
        }

        private void entfernenToolStripMenuItem_Click(object sender, EventArgs e)
        {
                listBox1.Items.Remove(listBox1.SelectedItem);    
            
            

        }

        private void chkUpload_CheckedChanged(object sender, EventArgs e)
        {
            if (chkUpload.Checked)
            {
                radioBtnFlickr.Enabled = true;
                radioBtnFTP.Enabled = true;
            }
            else
            {
                radioBtnFlickr.Enabled = false;
                radioBtnFTP.Enabled = false;
            }
        }

        private void radioBtnFlickr_CheckedChanged(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            if (radioBtnFlickr.Checked)
            {
                if (String.IsNullOrEmpty(_AppSettings.FlickrAuthToken))
                {
                    FlickrAccess fa = new FlickrAccess();
                    if (fa.startAuthMe() == DialogResult.OK)
                    {
                        try
                        {
                            fa.continueAuthMe();
                        }
                        catch (FlickrNet.FlickrException ex)
                        {
                            Console.WriteLine(ex.Message);
                            MessageBox.Show("Authentifizierung nicht erfolgreich.",
                                "Flickr! Authentifizierung",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Exclamation,
                                MessageBoxDefaultButton.Button1);
                        }
                    }
                    else
                    {
                        radioBtnFlickr.Checked = false;
                        chkUpload.Checked = false;
                    }
                }

            }
            Cursor.Current = Cursors.Default;
        }

        private void radioBtnFTP_CheckedChanged(object sender, EventArgs e)
        {
            if (radioBtnFTP.Checked)
            {
                FtpConfig ftpConfigDialog = new FtpConfig();
                DialogResult dr = ftpConfigDialog.ShowDialog();
                if (dr != DialogResult.OK)
                {
                    radioBtnFTP.Checked = false;
                }
            }
        }


        private static void FtpUpload(string ftpServer, string userName, string password, string path , string filename)
        {
            using (System.Net.WebClient client = new System.Net.WebClient())
            {
                if(!ftpServer.StartsWith("ftp://")){
                    ftpServer = "ftp://" + ftpServer;
                }
                client.Credentials = new System.Net.NetworkCredential(userName, password);
                client.UploadFile(ftpServer + path + "/" + new FileInfo(filename).Name, "STOR", filename);
            }
        }
	}//End of Class
}//End of Namespace
