using System;

namespace ImageResizer.util
{
	/// <summary>
	/// Klasse zum verarebiten der AppSettings.
	/// </summary>
	public class AppSetting
	{
		// Members
		private AppSettings _Parent;
		private string _Key;
		private string _Value;

		// Properties
		public string Key 
		{
			get
			{
				return this._Key;
			}
		}
		public string Value 
		{
			get
			{
				return this._Value;
			}
			set
			{
				this._Value = value;
				this.UpdateParent();
			}
		}

		//Constructors
		public AppSetting()
		{
		}

		public AppSetting(string Key, string Value) : this(Key, Value, null)
		{
		}

		internal AppSetting(string Key, string Value, AppSettings Parent)
		{
			this._Parent = Parent;
			this._Key = Key;
			this._Value = Value;
		}

		//Methods
		private void UpdateParent()
		{
			if (this._Parent != null)
			{
				this._Parent.Update(this);
			}

		}

	}
}
